package com.xypower.mpmaster.sms;

import android.Manifest;
import android.app.Activity;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Build;
import android.os.Bundle;
import android.telephony.SmsManager;
import android.telephony.SmsMessage;
import android.telephony.SubscriptionInfo;
import android.telephony.SubscriptionManager;
import android.text.TextUtils;

import androidx.core.app.ActivityCompat;

import com.dev.devapi.api.SysApi;
import com.xypower.common.RegexUtil;

import org.json.JSONArray;
import org.json.JSONException;

import java.io.IOException;
import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Set;
import java.util.TimeZone;


/*
 * 短信接收类
 *
 * */
public class SimUtil {
    public static final String SMS_RECEIVED_ACTION = "android.provider.Telephony.SMS_RECEIVED";
    public static final String SMS_DELIVER_ACTION = "android.provider.Telephony.SMS_DELIVER";

    //自定义ACTION常数 作为广播的IntentFilter识别常数
    public static String SMS_SEND_ACTION = "com.xypower.mpmaster.SMS_SEND_ACTION";
    public static String SMSTYPE = "smstype";
    public static String SMSDATA = "smsdata";

    public static String SMSIFCORRECT = "smsifcorrect";

    //短信解析
    public static void analysisSMSInfo(Intent intent, Context context) {
        SmsMessageModel smsInfo = getSMSInfo(intent);
        if (smsInfo != null) {
            String packageName = context.getApplicationContext().getPackageName();
            String content = smsInfo.getContent();
            int slot = smsInfo.getSlot();//那张卡收到的短信
            String sender = smsInfo.getSender();//收到的短信的手机号
            String sendmessage = "ERROR";//要回复的短信
            String sendtype = "";//收到的短信类型
            List<Integer> abslist = new ArrayList<>();//收到的短信内容拆分包装成数组
            boolean ifmessageCorrect = false;//用来判断收到的短信内容是否正确
            if (StringUtils.isEmpty(content)) {
                return;
            }
            if (content.contains(SmsTypeEnum.REBOOT1.value())) {
                ifmessageCorrect = true;
                sendmessage = content + " OK";
                sendtype = SmsTypeEnum.REBOOT1.value();
            } else if (content.contains(SmsTypeEnum.REBOOT2.value())) {
                ifmessageCorrect = true;
                sendmessage = content + " OK";
                sendtype = SmsTypeEnum.REBOOT2.value();
            } else if (content.contains(SmsTypeEnum.SET_YW_SCHEDULE.value())) {
                String[] split1 = StringUtils.splitString1(content);
                if (split1 != null && split1.length > 1) {
                    String s = split1[1];
                    String[] split2 = StringUtils.splitString2(s);
                    if (split2 != null && split2.length >= 1) {
                        int length = split2.length;
                        if (length % 2 == 1) {
                            String num = split2[0];
                            Integer integer = StringUtils.convert2Int(num);
                            if (integer != null) {
                                if (integer == 0) {//删除所有运维
                                    ifmessageCorrect = true;
                                } else {
                                    if (length == integer + 1) {
                                        int times = 0;
                                        for (int i = 0; i < split2.length; i++) {
                                            if (i == 0) {
                                                continue;
                                            }
                                            String ts = split2[i];
                                            Integer time = StringUtils.convert2Int(ts);
                                            if (i % 2 == 1) {
                                                if (time > 23) {
                                                    ifmessageCorrect = false;
                                                    break;
                                                }
                                                times = time * 60;
                                            } else {
                                                if (time > 59) {
                                                    ifmessageCorrect = false;
                                                    break;
                                                }
                                                times += time;
                                                abslist.add(times);
                                            }
                                        }
                                    }
                                }
                                if (ifmessageCorrect) {
                                    UpdateSysConfigUtil.setAbsHeartbeats(context, abslist);
                                }
                            }
                        }
                    }
                }
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
                sendtype = SmsTypeEnum.SET_YW_SCHEDULE.value();
            } else if (content.contains(SmsTypeEnum.GET_YW_SCHEDULE.value())) {
                ifmessageCorrect = true;
                List<Integer> absHeartbeats = UpdateSysConfigUtil.getAbsHeartbeats(context);
                if (absHeartbeats == null || absHeartbeats.size() == 0) {
                    sendmessage = SmsTypeEnum.GET_YW_SCHEDULE.value() + "=0";
                } else {
                    int length = absHeartbeats.size();
                    sendmessage = SmsTypeEnum.GET_YW_SCHEDULE.value() + "=" + length;
                    for (int i = 0; i < length; i++) {
                        int mAbsHeartbeatTime = 0;
                        mAbsHeartbeatTime = absHeartbeats.get(i);
                        int hour = mAbsHeartbeatTime / 60;
//                        int leftsecond = mAbsHeartbeatTime % 60;
                        int minute = mAbsHeartbeatTime % 60;
                        sendmessage += "," + hour + "," + minute;
                    }
                }
            } else if (content.contains(SmsTypeEnum.SET_OPERATE.value())) {
                sendtype = SmsTypeEnum.SET_OPERATE.value();
                String[] split1 = StringUtils.splitString1(content);
                if (split1 != null && split1.length > 1) {
                    String s = split1[1];
                    Integer integer = StringUtils.convert2Int(s);
                    if (integer != null) {
                        if (integer == 0 || integer == 1) {
                            ifmessageCorrect = true;
                            UpdateSysConfigUtil.setMntnMode(context, integer);
                        }
                    }
                }
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            } else if (content.contains(SmsTypeEnum.GET_OPERATE.value())) {
                sendtype = SmsTypeEnum.GET_OPERATE.value();
                ifmessageCorrect = true;
                int mntnMode = UpdateSysConfigUtil.getMntnMode(context);
                sendmessage = SmsTypeEnum.GET_OPERATE + "=" + mntnMode;
            } else if (content.contains(SmsTypeEnum.SET_OPERATE_URL.value())) {
                sendtype = SmsTypeEnum.SET_OPERATE_URL.value();
                String[] split1 = StringUtils.splitString1(content);
                if (split1 != null && split1.length > 1) {
                    String s = split1[1];
                    String[] split2 = StringUtils.splitString2(s);
                    if (split2 != null && split2.length == 2) {
                        String ipAddress = split2[0];
                        String port = split2[1];
                        boolean b = RegexUtil.checkIpAddress(ipAddress);
                        if (b) {
                            Integer integer = StringUtils.convert2Int(port);
                            if (integer != null) {
                                ifmessageCorrect = true;
                                UpdateSysConfigUtil.setMntnServer(context, ipAddress, integer);
                            }
                        }
                    }
                }
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            } else if (content.contains(SmsTypeEnum.GET_OPERATE_URL.value())) {
                sendtype = SmsTypeEnum.GET_OPERATE.value();
                ifmessageCorrect = true;
                String mntnServer = UpdateSysConfigUtil.getMntnServer(context);
                sendmessage = SmsTypeEnum.GET_OPERATE + "=" + mntnServer;
            } else if (content.contains(SmsTypeEnum.UPDATE.value())) {
                sendtype = SmsTypeEnum.UPDATE.value();
                String[] split1 = StringUtils.splitString1(content);
                if (split1 != null && split1.length == 2) {
                    ifmessageCorrect = true;
                    String s = split1[1];
                    DownloadUtils downloadUtils = new DownloadUtils(context.getApplicationContext(), s, "test.app");
                }
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            } else if (content.contains(SmsTypeEnum.SET_CMDID.value())) {
                sendtype = SmsTypeEnum.SET_CMDID.value();
                String[] split1 = StringUtils.splitString1(content);
                if (split1 != null && split1.length > 1) {
                    String cmdid = split1[1];
                    UpdateSysConfigUtil.setCmdid(context, cmdid);
                }
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            } else if (content.contains(SmsTypeEnum.GET_CMDID.value())) {
                sendtype = SmsTypeEnum.GET_CMDID.value();
                ifmessageCorrect = true;
                String cmdid = UpdateSysConfigUtil.getCmdid(context);
                sendmessage = SmsTypeEnum.GET_OPERATE + "=" + cmdid;
            } else if (content.contains(SmsTypeEnum.SET_IP.value())) {
                sendtype = SmsTypeEnum.SET_IP.value();
                String[] split1 = StringUtils.splitString1(content);
                if (split1 != null && split1.length > 1) {
                    String s = split1[1];
                    String[] split2 = StringUtils.splitString2(s);
                    if (split2 != null && (split2.length == 2 || split2.length == 4)) {
                        String server;
                        Integer integer;
                        server = split2[0];
                        String port = split2[1];
                        integer = StringUtils.convert2Int(port);
                        int utcp = -1;
                        int encrypto = -1;
                        if (integer != null) {
                            ifmessageCorrect = true;
                        }
                        if (split2.length == 4) {
                            String s1 = split2[2];
                            utcp = StringUtils.convert2Int(s1);
                            String s2 = split2[3];
                            encrypto = StringUtils.convert2Int(s2);
                        }
                        UpdateSysConfigUtil.setIP(context, server, integer, utcp, encrypto);
                    }
                }
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            } else if (content.contains(SmsTypeEnum.GET_IP.value())) {
                sendtype = SmsTypeEnum.GET_IP.value();
                ifmessageCorrect = true;
                String ip = UpdateSysConfigUtil.getIP(context);
                sendmessage = SmsTypeEnum.GET_IP + "=" + ip;
            } else if (content.contains(SmsTypeEnum.SET_OSD.value())) {
                sendtype = SmsTypeEnum.SET_OSD.value();
                String[] split1 = StringUtils.splitString1(content);
                if (split1 != null && split1.length > 1) {
                    String s = split1[1];
                    String[] split2 = StringUtils.splitString2(s);
                    if (split2 != null && split2.length == 2) {
                    }
                }
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            } else if (content.contains(SmsTypeEnum.GET_OSD.value())) {
                sendtype = SmsTypeEnum.GET_OSD.value();
                ifmessageCorrect = true;
            } else if (content.contains(SmsTypeEnum.SET_PHOTO_SCHEDULE_LIST.value())) {
                sendtype = SmsTypeEnum.SET_OSD.value();
                String[] split1 = StringUtils.splitString1(content);
                if (split1 != null && split1.length > 1) {
                    String s = split1[1];
                    String[] split2 = StringUtils.splitString1(s);
                    if (split2 != null && split2.length == 2) {
                    }
                }
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            } else if (content.contains(SmsTypeEnum.GET_PHOTO_SCHEDULE_LIST.value())) {
                sendtype = SmsTypeEnum.GET_PHOTO_SCHEDULE_LIST.value();
                ifmessageCorrect = true;
            } else if (content.contains(SmsTypeEnum.SET_RESOLUTION.value())) {
                sendtype = SmsTypeEnum.SET_RESOLUTION.value();
                String[] split1 = StringUtils.splitString1(content);
                if (split1 != null && split1.length > 1) {
                    String s = split1[1];
                    String[] split2 = StringUtils.splitString1(s);
                    if (split2 != null && split2.length == 5) {
                        Integer channel = StringUtils.convert2Int(split2[0]);
                        Integer resolutionCX = StringUtils.convert2Int(split2[1]);
                        Integer resolutionCY = StringUtils.convert2Int(split2[2]);
                        Integer videoCX = StringUtils.convert2Int(split2[3]);
                        Integer videoCY = StringUtils.convert2Int(split2[4]);
                        if (channel != null && resolutionCX != null && resolutionCY != null && videoCX != null && videoCY != null) {
                            ifmessageCorrect = true;
                            UpdateSysConfigUtil.setChannelResolution(packageName, channel, resolutionCX, resolutionCY, videoCX, videoCY);
                        }
                    }
                }
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            } else if (content.contains(SmsTypeEnum.GET_RESOLUTION.value())) {
                sendtype = SmsTypeEnum.GET_RESOLUTION.value();
                ifmessageCorrect = true;
                String[] split = StringUtils.splitString1(content);
                Integer channel = StringUtils.convert2Int(split[0]);
                HashMap<String, Integer> hashMap = UpdateSysConfigUtil.getChannelResolution(packageName, channel);
                Integer resolutionCX = hashMap.get("resolutionCX");
                Integer resolutionCY = hashMap.get("resolutionCY");
                Integer videoCX = hashMap.get("videoCX");
                Integer videoCY = hashMap.get("videoCY");
                sendmessage = SmsTypeEnum.GET_RESOLUTION.value() + "=" + resolutionCX + "," + resolutionCY + "," + videoCX + "," + videoCY;
            } else if (content.contains(SmsTypeEnum.SET_HEART.value())) {
                sendtype = SmsTypeEnum.SET_HEART.value();
                String[] split1 = StringUtils.splitString1(content);
                if (split1 != null && split1.length == 2) {
                    ifmessageCorrect = true;
                    String s = split1[1];
                    Integer integer = StringUtils.convert2Int(s);
                    UpdateSysConfigUtil.setHB(context, integer);
                }
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            } else if (content.contains(SmsTypeEnum.GET_HEART.value())) {
                sendtype = SmsTypeEnum.GET_HEART.value();
                ifmessageCorrect = true;
                int hb = UpdateSysConfigUtil.getHB(context);
                sendmessage = SmsTypeEnum.GET_HEART.value() + "=" + hb;
            } else if (content.contains(SmsTypeEnum.SET_TP.value())) {
                sendtype = SmsTypeEnum.SET_TP.value();
                String[] split1 = StringUtils.splitString1(content);
                if (split1 != null && split1.length == 2) {
                    ifmessageCorrect = true;
                    String s = split1[1];
                    Integer integer = StringUtils.convert2Int(s);
                    UpdateSysConfigUtil.setTB(context, integer);
                }
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            } else if (content.contains(SmsTypeEnum.GET_TP.value())) {
                sendtype = SmsTypeEnum.GET_TP.value();
                ifmessageCorrect = true;
                String[] split = StringUtils.splitString1(content);
                int tb = UpdateSysConfigUtil.getTB(context);
                sendmessage = SmsTypeEnum.GET_TP.value() + "=" + tb;
            } else if (content.contains(SmsTypeEnum.SET_PACKAGE.value())) {
                sendtype = SmsTypeEnum.SET_PACKAGE.value();
                String[] split1 = StringUtils.splitString1(content);
                if (split1 != null && split1.length == 2) {
                    ifmessageCorrect = true;
                    String s = split1[1];
                    Integer integer = StringUtils.convert2Int(s);
                    UpdateSysConfigUtil.setPackage(context, integer);
                }
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            } else if (content.contains(SmsTypeEnum.GET_PACKAGE.value())) {
                sendtype = SmsTypeEnum.GET_PACKAGE.value();
                ifmessageCorrect = true;
                int aPackage = UpdateSysConfigUtil.getPackage(context);
                sendmessage = SmsTypeEnum.GET_PACKAGE.value() + "=" + aPackage;
            } else if (content.contains(SmsTypeEnum.CLEAR_PHOTO.value())) {
                sendtype = SmsTypeEnum.CLEAR_PHOTO.value();
                ifmessageCorrect = true;
                UpdateSysConfigUtil.clearHistoryPic(context);
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            } else if (content.contains(SmsTypeEnum.CLEAR_LOG.value())) {
                sendtype = SmsTypeEnum.CLEAR_LOG.value();
                ifmessageCorrect = true;
                UpdateSysConfigUtil.clearHistoryLogs(context);
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            } else if (content.contains(SmsTypeEnum.CLEAR_ALL.value())) {
                sendtype = SmsTypeEnum.CLEAR_ALL.value();
                ifmessageCorrect = true;
                UpdateSysConfigUtil.clearHistoryPic(context);
                UpdateSysConfigUtil.clearHistoryLogs(context);
                String menssageBack = "";
                if (ifmessageCorrect) {
                    menssageBack = " OK";
                } else {
                    menssageBack = " ERROR";
                }
                sendmessage = content + menssageBack;
            }
            sendSms(context, slot, sender, sendmessage, sendtype, ifmessageCorrect);
        }

    }

    //短信解析
    public static SmsMessageModel getSMSInfo(Intent intent) {
        SmsMessageModel smsMessageModel = new SmsMessageModel();
        String action = intent.getAction();
        if (SMS_RECEIVED_ACTION.equals(action) || SMS_DELIVER_ACTION.equals(action)) {
            Bundle bundle = intent.getExtras();
            if (bundle != null) {
                StringBuilder content = new StringBuilder();
                String sender = "";
                String dateContent = "";
                Object[] pdus = (Object[]) bundle.get("pdus");
                if (pdus != null && pdus.length > 0) {
                    SmsMessage[] messages = new SmsMessage[pdus.length];
                    for (int i = 0; i < pdus.length; i++) {
                        byte[] pdu = (byte[]) pdus[i];
                        messages[i] = SmsMessage.createFromPdu(pdu);
                    }
                    for (SmsMessage message : messages) {
                        content.append(message.getMessageBody());// 得到短信内容
                        // 得到发信息的号码
                        sender = message.getOriginatingAddress();
                        Date date = new Date(message.getTimestampMillis());
                        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
                        format.setTimeZone(TimeZone.getTimeZone("GMT+08:00"));
                        dateContent = format.format(date);
                    }
                    int smsSlot = getSmsSlot(bundle);
                    smsMessageModel.setContent(content.toString());
                    smsMessageModel.setSender(sender);
                    smsMessageModel.setDateContent(dateContent);
                    smsMessageModel.setSlot(smsSlot);
                }
            }
        }
        return smsMessageModel;
    }

    //获取是哪个sim卡收到短信
    private static int getSmsSlot(Bundle bundle) {
        int slot = -1;
        Set<String> keySet = bundle.keySet();
        for (String key : keySet) {
            switch (key) {
                case "slot":
                    slot = bundle.getInt("slot", -1);
                    break;
                case "simId":
                    slot = bundle.getInt("simId", -1);
                    break;
                case "simSlot":
                    slot = bundle.getInt("simSlot", -1);
                    break;
                case "slot_id":
                    slot = bundle.getInt("slot_id", -1);
                    break;
                case "simnum":
                    slot = bundle.getInt("simnum", -1);
                    break;
                case "slotId":
                    slot = bundle.getInt("slotId", -1);
                    break;
                case "slotIdx":
                    slot = bundle.getInt("slotIdx", -1);
                    break;
                case "android.telephony.extra.SLOT_INDEX":
                    slot = bundle.getInt("android.telephony.extra.SLOT_INDEX", -1);
                    break;
                default:
                    if (key.toLowerCase().contains("slot") | key.toLowerCase().contains("sim")) {
                        String value = bundle.getString(key, "-1");
                        if (value.equals("0") | value.equals("1") | value.equals("2")) {
                            slot = bundle.getInt(key, -1);
                        }
                    }
            }
        }
        return slot;
    }

    //指定sim卡位置发送短信
    public static void sendSms(Context mContext, int slot, String sender, String message, String value, boolean ifmessageCorrect) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP_MR1) {
            SubscriptionManager localSubscriptionManager = SubscriptionManager.from(mContext);
            if (ActivityCompat.checkSelfPermission(mContext, Manifest.permission.READ_PHONE_STATE) != PackageManager.PERMISSION_GRANTED) {
                return;
            }
            if (localSubscriptionManager.getActiveSubscriptionInfoCount() > 1) {
                List localList = localSubscriptionManager.getActiveSubscriptionInfoList();

                SubscriptionInfo simInfo1 = (SubscriptionInfo) localList.get(0);
                SubscriptionInfo simInfo2 = (SubscriptionInfo) localList.get(1);
                SubscriptionInfo simInfoAnother;
                if (slot == 0) {
                    simInfoAnother = simInfo1;
                } else {
                    simInfoAnother = simInfo2;
                }
                Intent itSend = new Intent(SMS_SEND_ACTION);
                itSend.putExtra(SMSTYPE, value);
                itSend.putExtra(SMSIFCORRECT, ifmessageCorrect);
//                itSend.putExtra(SMSDATA, (Serializable) jsonArray);
                //sendIntent参数为传送后接受的广播信息PendingIntent
                PendingIntent sendPI = PendingIntent.getBroadcast(mContext, 0, itSend, 0);

//                Intent itDeliver = new Intent(SMS_DELIVERED_ACTION);
                //deliveryIntent参数为传送后接受的广播信息PendingIntent
//                PendingIntent deliverPI = PendingIntent.getBroadcast(mContext,0,itDeliver,0);
                SmsManager.getSmsManagerForSubscriptionId(simInfoAnother.getSubscriptionId()).sendTextMessage(sender, null, message, sendPI, null);
            }
        }
    }


    //判断是否是双卡
    public static boolean isDoubleSim(Context mContext) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP_MR1) {
            SubscriptionManager manager = SubscriptionManager.from(mContext);
            if (ActivityCompat.checkSelfPermission(mContext, Manifest.permission.READ_PHONE_STATE) != PackageManager.PERMISSION_GRANTED) {
                return false;
            }
            int count = manager.getActiveSubscriptionInfoCount();
            if (count == 2) {
                return true;
            }
        }
        return false;
    }

    //通过卡槽id获取sim卡的信息0代码卡槽1，1代表卡槽2
    public static String getSlotIdInfo(Context mContext, int slotId) {
        String info = "";
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP_MR1) {
            SubscriptionManager manager = SubscriptionManager.from(mContext);
            if (ActivityCompat.checkSelfPermission(mContext, Manifest.permission.READ_PHONE_STATE) != PackageManager.PERMISSION_GRANTED) {
                return "";
            }
            SubscriptionInfo subInfo = manager.getActiveSubscriptionInfoForSimSlotIndex(slotId);
            if (subInfo != null) {
                info = subInfo.getCarrierName().toString();
            }
        }
        return info;
    }

    //判断手机中是否装了双卡
    public static boolean isHasDoubleSim(Context mContext) {
        try {
            if (isDoubleSim(mContext)) {
                List<ModelSlotAndSub> slotAndSubs = getModelSlot(mContext);
                if (slotAndSubs != null && slotAndSubs.size() == 2) {
                    return true;
                } else {
                    return false;
                }
            } else {
                return false;
            }
        } catch (Exception e) {
            e.printStackTrace();
            return false;
        }
    }


    //判断是否拥有该权限
    public static boolean IsHasPermission(Context mContext, String permission) {
        if (mContext != null) {
            if (ActivityCompat.checkSelfPermission(mContext, permission) != PackageManager.PERMISSION_GRANTED) {
                return false;
            }
        } else {
            return false;
        }
        return true;
    }


    //申请该权限
    public static void requestOnePermission(Activity activity, String permission, int permissionCode) {
        if (activity != null) {
            activity.requestPermissions(new String[]{permission}, permissionCode);
        }
    }


    //获取icc用来判断
    public static int getIcc(String iccid, List<ModelSlotAndSub> slotAndSubs) {
        int icc = 0;
        if (slotAndSubs != null && slotAndSubs.size() >= 2 && !TextUtils.isEmpty(iccid)) {
            if (iccid.startsWith(slotAndSubs.get(0).iccid)) {
                icc = 1;
            } else if (iccid.startsWith(slotAndSubs.get(1).iccid)) {
                icc = 2;
            } else {
                if (iccid.equals(slotAndSubs.get(0).subId)) {
                    icc = 1;
                } else if (iccid.equals(slotAndSubs.get(1).subId)) {
                    icc = 2;
                } else {
                    icc = 0;
                }
            }
        }
        return icc;
    }

    /**
     * 获取来自那张卡 即卡1 还是卡2
     *
     * @param mContext
     * @param subID
     * @return
     */
    public static int getSlot(Context mContext, String subID) {
        return getIcc(subID, getModelSlot(mContext));
    }

    //获取对应的卡槽ID和iccID 关联
    private static List<ModelSlotAndSub> getModelSlot(Context mContext) {
        List<ModelSlotAndSub> data = new ArrayList<>();
        ModelSlotAndSub modelSlotAndSub = null;
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP_MR1) {
            SubscriptionManager subscriptionManager = SubscriptionManager.from(mContext);
            if (ActivityCompat.checkSelfPermission(mContext, Manifest.permission.READ_PHONE_STATE) == PackageManager.PERMISSION_GRANTED) {
                List<SubscriptionInfo> mSubcriptionInfos = subscriptionManager.getActiveSubscriptionInfoList();
                if (mSubcriptionInfos != null) {
                    for (int i = 0; i < mSubcriptionInfos.size(); i++) {
                        SubscriptionInfo info = mSubcriptionInfos.get(i);
                        if (info != null) {
                            modelSlotAndSub = new ModelSlotAndSub();
                            modelSlotAndSub.subId = info.getSubscriptionId() + "";
                            modelSlotAndSub.simSlot = info.getSimSlotIndex() + 1 + "";
                            modelSlotAndSub.iccid = info.getIccId();
                            data.add(modelSlotAndSub);
                        }
                    }
                    if (data != null && data.size() == 2) {
                        if (!TextUtils.isEmpty(data.get(0).simSlot) && !TextUtils.isEmpty(data.get(1).simSlot)) {
                            int simSlot1 = Integer.valueOf(data.get(0).simSlot);
                            int simSlot2 = Integer.valueOf(data.get(1).simSlot);
                            if (simSlot1 > simSlot2) {
                                ModelSlotAndSub modelSlotAndSub1 = data.get(1);
                                data.remove(data.get(1));
                                data.add(0, modelSlotAndSub1);
                            }
                        }
                    }
                }
            }
        }
        return data;
    }

}