package com.xypower.mpmaster.sms;

import static com.xypower.common.MicroPhotoContext.PACKAGE_NAME_MPAPP;
import static com.xypower.common.MicroPhotoContext.buildMpAppDir;

import android.content.Context;
import android.os.Environment;

import com.xypower.common.FileUtils;
import com.xypower.common.JSONUtils;
import com.xypower.common.MicroPhotoContext;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

public class UpdateSysConfigUtil {
    public static final String PACKAGE_NAME_MPAPP = "com.xypower.mpapp";

    //创建运维配置文件文件夹
    public static String buildAppDir(String packageurl) {
        String path = Environment.getExternalStorageDirectory().getAbsolutePath();
        if (!path.endsWith(File.separator)) {
            path += File.separator;
        }

        path += packageurl + File.separator;
        File pathFile = new File(path);
        if (!pathFile.exists() && !pathFile.mkdirs()) {
            return null;
        }

        return path;
    }

    //获取配置文件地址
    public static String getChannelDir(int channel) {
        String appPath = buildAppDir(PACKAGE_NAME_MPAPP);
        String path = appPath + "data/channels/" + channel + ".json";
        return path;
    }

    //修改运维时间表
    public static void setAbsHeartbeats(Context context, List<Integer> list) {
        MicroPhotoContext.MasterConfig masterConfig = MicroPhotoContext.getMasterConfig(context);
        int[] array = new int[list.size()];
        if (list != null && list.size() > 0) {
            for (int i = 0; i < list.size(); i++) {
                array[i] = list.get(i);
            }
        }
        masterConfig.absHeartbeats = array;
        MicroPhotoContext.saveMasterConfig(context, masterConfig);
    }

    //获取运维时间表
    public static List getAbsHeartbeats(Context context) {
        MicroPhotoContext.MasterConfig masterConfig = MicroPhotoContext.getMasterConfig(context);
        ArrayList<Integer> list = new ArrayList<>();
        int[] absHeartbeats = masterConfig.absHeartbeats;
        if (absHeartbeats != null && absHeartbeats.length > 0) {
            for (int i = 0; i < absHeartbeats.length; i++) {
                list.add(absHeartbeats[i]);
            }
        }
        return list;
    }

    //修改运维状态
    public static void setMntnMode(Context context, int mntnMode) {
        MicroPhotoContext.MasterConfig masterConfig = MicroPhotoContext.getMasterConfig(context);
        masterConfig.mntnMode = mntnMode;
        MicroPhotoContext.saveMasterConfig(context, masterConfig);
    }

    //查询运维状态
    public static int getMntnMode(Context context) {
        MicroPhotoContext.MasterConfig masterConfig = MicroPhotoContext.getMasterConfig(context);
        return masterConfig.mntnMode;
    }

    //修改运维状态
    public static void setMntnServer(Context context, String server, int port) {
        MicroPhotoContext.MasterConfig masterConfig = MicroPhotoContext.getMasterConfig(context);
        masterConfig.server = server;
        masterConfig.port = port;
        MicroPhotoContext.saveMasterConfig(context, masterConfig);
    }

    //查询运维状态
    public static String getMntnServer(Context context) {
        String server = "";
        int port;
        MicroPhotoContext.MasterConfig masterConfig = MicroPhotoContext.getMasterConfig(context);
        server = masterConfig.server;
        port = masterConfig.port;
        return server + "," + port;
    }


    //修改cmdid
    public static void setCmdid(Context context, String cmdid) {
        MicroPhotoContext.AppConfig mpAppConfig = MicroPhotoContext.getMpAppConfig(context);
        mpAppConfig.cmdid = cmdid;
        MicroPhotoContext.saveMpAppConfig(context, mpAppConfig);
    }


    //查询cmdid
    public static String getCmdid(Context context) {
        MicroPhotoContext.AppConfig mpAppConfig = MicroPhotoContext.getMpAppConfig(context);
        return mpAppConfig.cmdid;
    }

    //修改app的ip
    public static void setIP(Context context, String server, int port, int utcp, int encrypto) {
        MicroPhotoContext.AppConfig mpAppConfig = MicroPhotoContext.getMpAppConfig(context);
        mpAppConfig.server = server;
        mpAppConfig.port = port;
        if (utcp != -1) {
            mpAppConfig.networkProtocol = utcp;
        }
        if (encrypto != -1) {
            mpAppConfig.encryption = encrypto;
        }
        MicroPhotoContext.saveMpAppConfig(context, mpAppConfig);
    }


    //查询cmdid
    public static String getIP(Context context) {
        MicroPhotoContext.AppConfig mpAppConfig = MicroPhotoContext.getMpAppConfig(context);
        String server = mpAppConfig.server;
        int port = mpAppConfig.port;
        int networkProtocol = mpAppConfig.networkProtocol;
        int encryption = mpAppConfig.encryption;
        return server + "," + port + "," + networkProtocol + "," + encryption;
    }

    //修改app的心跳
    public static void setHB(Context context, int heart) {
        MicroPhotoContext.AppConfig mpAppConfig = MicroPhotoContext.getMpAppConfig(context);
        mpAppConfig.heartbeat = heart;
        MicroPhotoContext.saveMpAppConfig(context, mpAppConfig);
    }


    //获取app的心跳
    public static int getHB(Context context) {
        MicroPhotoContext.AppConfig mpAppConfig = MicroPhotoContext.getMpAppConfig(context);
        int heartbeat = mpAppConfig.heartbeat;
        return heartbeat;
    }


    //修改传输协议
    public static void setTB(Context context, int tp) {
        MicroPhotoContext.AppConfig mpAppConfig = MicroPhotoContext.getMpAppConfig(context);
        mpAppConfig.networkProtocol = tp;
        MicroPhotoContext.saveMpAppConfig(context, mpAppConfig);
    }


    //获取传输协议
    public static int getTB(Context context) {
        MicroPhotoContext.AppConfig mpAppConfig = MicroPhotoContext.getMpAppConfig(context);
        int heartbeat = mpAppConfig.networkProtocol;
        return heartbeat;
    }


    //设置传输包大小
    public static void setPackage(Context context, int tp) {
        MicroPhotoContext.AppConfig mpAppConfig = MicroPhotoContext.getMpAppConfig(context);
        mpAppConfig.packetSize = tp;
        MicroPhotoContext.saveMpAppConfig(context, mpAppConfig);
    }


    //获取传输包大小
    public static int getPackage(Context context) {
        MicroPhotoContext.AppConfig mpAppConfig = MicroPhotoContext.getMpAppConfig(context);
        int heartbeat = mpAppConfig.packetSize;
        return heartbeat;
    }

    //设置通道分辨率
    public static boolean setChannelResolution(String packageurl, int channel, int resolutionCX, int resolutionCY, int videoCX, int videoCY) {
        String path = getChannelDir(channel);
        JSONObject jsonObject = JSONUtils.loadJson(path);
        try {
            jsonObject.put("resolutionCX", resolutionCX);
            jsonObject.put("resolutionCY", resolutionCY);
            jsonObject.put("videoCX", videoCX);
            jsonObject.put("videoCY", videoCY);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return JSONUtils.saveJson(path, jsonObject);
    }

    //查询通道分辨率
    public static HashMap getChannelResolution(String packageurl, int channel) {
        HashMap<String, Integer> hashMap = new HashMap<>();
        String path = getChannelDir(channel);
        JSONObject jsonObject = JSONUtils.loadJson(path);
        try {
            int resolutionCX = jsonObject.getInt("resolutionCX");
            int resolutionCY = jsonObject.getInt("resolutionCY");
            int videoCX = jsonObject.getInt("videoCX");
            int videoCY = jsonObject.getInt("videoCY");

            hashMap.put("resolutionCX", resolutionCX);
            hashMap.put("resolutionCY", resolutionCY);
            hashMap.put("videoCX", videoCX);
            hashMap.put("videoCY", videoCY);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return hashMap;
    }


    //清除历史图片和视频
    public static void clearHistoryPic(Context context) {
        String appPath = MicroPhotoContext.buildMpAppDir(context);

        File path = new File(appPath + "photos/");
        if (path.exists() && path.isDirectory()) {
            FileUtils.DeleteFilesInPath(path.getAbsolutePath());
        }

        path = new File(appPath + "sentPhotos/");
        if (path.exists() && path.isDirectory()) {
            FileUtils.DeleteFilesInPath(path.getAbsolutePath());
        }

    }

    //清除日志
    public static void clearHistoryLogs(Context context) {
        String appPath = MicroPhotoContext.buildMpAppDir(context);
        String masterAppDir = MicroPhotoContext.buildMasterAppDir(context);

        File path = new File(appPath + "logs/");
        if (path.exists() && path.isDirectory()) {
            FileUtils.DeleteFilesInPath(path.getAbsolutePath());
        }

        path = new File(masterAppDir + "logs/");
        if (path.exists() && path.isDirectory()) {
            FileUtils.DeleteFilesInPath(path.getAbsolutePath());
        }

    }


}
